local Widgets = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Widgets")
local Loc = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Localisation")
local _ARTG = _Avyr_Raid_Tools_ADDON_Globals

--local Tooltip = _Avyr_GUI_Widgets_Tooltip;
local CreateFrame, Minimap, atan2, cos, sin, GetCursorPosition, insert, pairs, UIParent = CreateFrame, Minimap, atan2, cos, sin, GetCursorPosition, table.insert, pairs, UIParent;

_ARTG.SV.RegisterSVCallback(function(varName,varValue)
	_ARTG.MinimapIcon:Refresh()
end,"ALL","G_Enable","MI_Enable","MI_PosX","MI_PosY")

local function SetMinimapIconPosition(self,fromSV)
	local shape = GetMinimapShape and GetMinimapShape() or "ROUND"
	local PosX = -12
	local PosY = -80
	if shape == "ROUND" then 
		if fromSV then 
			local x,y  =  _ARTG.SV.GetVariable("MI_PosX"), _ARTG.SV.GetVariable("MI_PosY")
			PosX = x or PosX
			PosY = y or PosY
		--check position is valid
		else 
			local MapX, MapY = Minimap:GetCenter();
			local MouseX, MouseY = GetCursorPosition();
			local MapScale = Minimap:GetEffectiveScale();
			MapX = MapX * MapScale;
			MapY = MapY * MapScale;
			local Ang = atan2(MouseY - MapY, MouseX - MapX);
			PosX = 80 * cos(Ang);
			PosY = 80 * sin(Ang);
		end 
	else 
		if fromSV then 
			local x,y  =  _ARTG.SV.GetVariable("MI_PosX"), _ARTG.SV.GetVariable("MI_PosY")
			PosX = x or PosX
			PosY = y or PosY
		else	
			local MapX, MapY = Minimap:GetCenter();
			local MouseX, MouseY = GetCursorPosition();
			local MapScale = Minimap:GetEffectiveScale();

			MapX = MapX * MapScale;
			MapY = MapY * MapScale;
			PosX = MouseX - MapX
			PosY = MouseY - MapY

			PosY = PosY / MapScale
			PosX = PosX / MapScale

		end		

		local distanceToEdgeX = abs(abs(PosX) - Minimap:GetWidth() / 2)
		local distanceToEdgeY = abs(abs(PosY) - Minimap:GetHeight() / 2)

		if abs(PosX) > Minimap:GetWidth() / 2 then 
			PosX = (PosX / abs(PosX)) * Minimap:GetWidth() / 2
		elseif abs(PosY) > Minimap:GetHeight() / 2 then 
			PosY = (PosY / abs(PosY)) * Minimap:GetHeight() / 2
		elseif distanceToEdgeX <= distanceToEdgeY then 
			PosX = (PosX / abs(PosX)) * Minimap:GetWidth() / 2
		else 
			PosY = (PosY / abs(PosY)) * Minimap:GetHeight() / 2
		end 

		if PosX >= Minimap:GetWidth() / 2 then 
			PosX = Minimap:GetWidth() / 2
		elseif PosX <= -Minimap:GetWidth() / 2 then 
			PosX = - Minimap:GetWidth() / 2
		end
		if PosY >= Minimap:GetHeight() / 2 then 
			PosY = Minimap:GetHeight() / 2
		elseif PosY <= -Minimap:GetHeight() / 2 then 
			PosY = - Minimap:GetHeight() / 2
		end
	end 

	self:SetPoint("CENTER", PosX, PosY);
end

local MinimapIcon = CreateFrame("Button", nil, Minimap);
MinimapIcon:SetSize(32, 32);
MinimapIcon:SetFrameStrata("MEDIUM");
MinimapIcon:SetPoint("CENTER", -12, -80);
MinimapIcon:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight");
MinimapIcon:RegisterForDrag("LeftButton");
MinimapIcon.Backdrop = MinimapIcon:CreateTexture(nil, "BACKGROUND");
MinimapIcon.Backdrop:SetAllPoints();
MinimapIcon.Backdrop:SetTexture("Interface\\PETBATTLES\\BattleBar-AbilityBadge-Neutral")

MinimapIcon.Icon = Widgets:FetchTexture(MinimapIcon,"BORDER")
--MinimapIcon.Icon = MinimapIcon:CreateTexture(nil, "BORDER");
MinimapIcon.Icon:SetSize(20, 20);
MinimapIcon.Icon:SetPoint("CENTER");
MinimapIcon.Icon:SetTexture("Interface\\AddOns\\AvyrRaidTools\\Widgets\\Media\\art_64_white")
Widgets:SetThemedColor(MinimapIcon.Icon,"Highlight")

MinimapIcon.Border = MinimapIcon:CreateTexture(nil, "BORDER",nil,1);
MinimapIcon.Border:SetAllPoints();
MinimapIcon.Border:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder");
MinimapIcon.Border:SetTexCoord(-0.025, 0.625, -0.05, 0.6);
MinimapIcon.Border:SetRotation(-1.57079632679);

MinimapIcon:SetScript("OnEnter", function(self)
	Widgets:SetTooltip(self,Loc:Translation("ART_MINIMAP_ICON_TOOLTIP_STRING"),-8,-8);
end)


MinimapIcon:SetScript("OnLeave", function()
	Widgets:SetTooltip(self)
end)

MinimapIcon:SetScript("OnDragStart", function(self)
	if not self.isLocked then
		self:SetScript("OnUpdate", function(self)
			SetMinimapIconPosition(self)
		end)
	end
end)

MinimapIcon:SetScript("OnDragStop", function(self)
	self:SetScript("OnUpdate", nil);
	local _, _, _, x, y = self:GetPoint(1);
	_ARTG.SV.SaveVariable("MI_PosX", x);
	_ARTG.SV.SaveVariable("MI_PosY", y);
end)

MinimapIcon:SetScript("OnMouseUp", function(self, button)
	if button == "RightButton" then
		_ARTG.Editor:Call();
	else
		_ARTG.OptionsMenu:QuickCall();
	end 
end)

MinimapIcon.Refresh = function(self)
	if _ARTG.SV.GetVariable("MI_Enable") then
		self:Show();
		SetMinimapIconPosition(self,true)
		if _ARTG.SV.GetVariable("G_Enable") then
			self.Icon:SetDesaturated(false);
		else
			self.Icon:SetDesaturated(true);
		end
	else
		self:Hide();
	end
end

_ARTG.MinimapIcon = MinimapIcon;
